window.agent_IE = 
			((navigator.appName == 'Microsoft Internet Explorer' || 
			!!(navigator.userAgent.match(/Trident/) || 
			navigator.userAgent.match(/rv:11/)) ||
			(typeof $.browser !== "undefined" && $.browser.msie == 1)));
if (agent_IE) {
	console.warn("You are likely using Internet Explorer as some features may become disabled. If anyhting fails to work, please see our static HTML page.");
}
String.prototype.replaceAll = function(search, replacement) {
	var target = this;
	return target.split(search).join(replacement);
};

function startLoading() {
	//See if there is an XML file downloaded

	if (window.localStorage.getItem("sizeError") == null || window.localStorage.getItem("sizeError") == "false") {
		
		var url_string = window.location.href;
		var url = new URL(url_string);
		var load = url.searchParams.get("load");
		var database = localStorage.getItem("database");

		if (database === null || load == "always") {
			//DB not present
			downloadXML();
		} else {
			//DB preseent
			var data = document.createElement("shop");
			data.innerHTML = database;
			renderPage(data.getElementsByTagName('shop')[0]);
			$.ajax({
				type:'GET',
				url: 'ddataversion.txt',
				data: {},
				success: function(data) {
					if (window.localStorage.getItem("XMLVersion") != data) {
						//update XML & update page
						downloadXML(true);
					}
				}, error: function(jqXHR, textStatus, errorThrown) {
					console.log(errorThrown);
				}
			});
		}
	}
}

function updateVersion() {
	$.ajax({
		type:'GET',
		url: 'ddataversion.txt',
		data: {},
		success: function(version) {
			window.localStorage.setItem("XMLVersion",version);
		}, error: function(jqXHR, textStatus, errorThrown) {
			console.log(errorThrown);
		}
	});
}

function downloadXML(update = false) {

	$.ajax({
		type:'GET',
		url: 'ddata.xml',
		data: {},
		success: function(data) {
			saveXML(data);
			updateVersion();
			//Render/update the page
			if (document.readyState == 'interactive' || document.readyState == 'complete') {
				renderPage(data,update);
			} else {
				window.onload = function() {
					renderPage(data,update);
				}
			}
		}, error: function(jqXHR, textStatus, errorThrown) {
			console.log(errorThrown);
		}
	});
}

function saveXML(data) {

	try {
		var s = new XMLSerializer();
		localStorage.setItem("database", s.serializeToString(data));
	} catch(domException) {
		if (domException.name === 'QuotaExceededError' ||
			domException.name === 'NS_ERROR_DOM_QUOTA_REACHED') {
			window.localStorage.setItem("localError", "true");
		}
	}

}

function renderPage(data,update=false) {

	var url_string = window.location.href;
	var url = new URL(url_string);
	var id = url.searchParams.get("id");

	document.getElementById("lot_id").value = id;

	var item = findElement(data,id);

	if (!update) {
		if (item == "findError") {
			document.getElementById("title").innerHTML = "Sorry, item not found.   . :(";
		} else {
			if (!item.querySelector("desc1")) {
				//redirect to old format page
				window.location.replace("https://german242.com/sh/"+item.querySelector("itemlink").innerHTML);
			} else {
				//Fill in text
				var numberSpan = document.createElement("span");
				var titleSpan = document.createElement("span");
				titleSpan.setAttribute("itemprop","name");
				titleSplit = item.querySelector("title").innerHTML.split(" ");

				numberSpan.innerHTML = titleSplit[0];
				titleSpan.innerHTML = titleSplit.slice(1,titleSplit.length).join(" ");

				document.getElementById("title").innerHTML = numberSpan.outerHTML + " " + titleSpan.outerHTML;
				document.getElementById("desc1").innerHTML = item.querySelector("desc1").innerHTML.replaceAll("\\n", "<br>");
				document.getElementById("desc2").innerHTML = item.querySelector("desc2").innerHTML.replaceAll("\\n", "<br>");
				document.getElementById("desc3").innerHTML = item.querySelector("desc3").innerHTML.replaceAll("\\n", "<br>");

				fillPrice(item);
				
				document.getElementById("meta_description").content = item.querySelector("desc").innerHTML.replaceAll("\\n", "<br>");

				categoryFill(item.getAttribute("category"));
				mobileAdapt();
				makeImages(id, item.querySelector("photo_count").innerHTML);
				makeStats(item);
			}
		}
	} else {
		//Just update the text
		var numberSpan = document.createElement("span");
		var titleSpan = document.createElement("span");
		titleSpan.setAttribute("itemprop","name");
		titleSplit = item.querySelector("title").innerHTML.split(" ");

		numberSpan.innerHTML = titleSplit[0];
		titleSpan.innerHTML = titleSplit.slice(1,titleSplit.length).join(" ");

		document.getElementById("title").innerHTML = numberSpan.outerHTML + " " + titleSpan.outerHTML;
		document.getElementById("desc1").innerHTML = item.querySelector("desc1").innerHTML.replaceAll("\\n", "<br>");
		document.getElementById("desc2").innerHTML = item.querySelector("desc2").innerHTML.replaceAll("\\n", "<br>");
		document.getElementById("desc3").innerHTML = item.querySelector("desc3").innerHTML.replaceAll("\\n", "<br>");

		fillPrice(item);
	}

	//Display ads & trackers once the page loads
	if (document.readyState == 'interactive' || document.readyState == 'complete') {
		finishedRendering();
	} else {
		if (window.onload != null) {
			window.onload = function() {
				document.getElementsByClassName("item_pic")[0].style.width = "100%";
				document.getElementsByClassName("form-box")[0].style.width = "100%";
				document.getElementsByClassName("item_desc_1")[0].style.width = "100%";
				finishedRendering();
			}
		} else {
			window.onload = function() {
				finishedRendering();
			}
		}
	}
}

function findElement(data,id) {
	var items = data.getElementsByTagName("item");
	for (var i = 0; i < items.length; i++) {
		if (items[i].getAttribute("id") == id) {
			return items[i];
		}		
	}
	return "findError";
}

function fillPrice(item) {
	if (item.querySelector("sold").innerHTML == "0") {
		var price = item.querySelector("price").innerHTML;
		var price_element = document.getElementById("price_element");
		var priceSpan = document.createElement("span");
		var currencySpan = document.createElement("span");
		priceSpan.setAttribute("itemprop","price");

		if (item.querySelector("sale").innerHTML == "0") {
			//normal
			priceSplit = price.split(" ");
			price_element.innerHTML = " : ";
			priceSpan.innerHTML = priceSplit[0];//first thingy e.g. number
			currencySpan.innerHTML = priceSplit.slice(1,priceSplit.length).join(" ");//all stuff after 1st thingy
			price_element.innerHTML += priceSpan.outerHTML + " " + currencySpan.outerHTML;
		} else {
			//promotional
			saleSplit = item.querySelector("sale").innerHTML.split(" ");
			price_element.innerHTML = "  : ";
			priceSpan.innerHTML = saleSplit[0];
			currencySpan.innerHTML = saleSplit.slice(1,saleSplit.length).join(" ");//all stuff after 1st thingy
			price_element.innerHTML += priceSpan.outerHTML + " " + currencySpan.outerHTML;
			price_element.innerHTML += "<br><del> : " + price + "</del>";

			price = item.querySelector("sale").innerHTML;//for the function below
		}
		price_element.innerHTML += "<link itemprop='availability' href='http://schema.org/InStock' />";//structured data
		document.getElementById("price_field").value = price; //this is for the form

		var currency = price.split(" ");
		if (!isNaN(currency[0])&&price != "0" && price != "-" && price != "") {
			var currencies = {".":"RUB","":"RUB","$":"USD","":"EUR","":"EUR"};
			if (currencies[currency[1]] !== undefined) {
				price_element.innerHTML += "<meta itemprop='priceCurrency' content='"+currencies[currency[1]]+"'>";
			} else {
				price_element.innerHTML += "<meta itemprop='priceCurrency' content='"+currency[1]+"'>";
			}
		}

	} else {
		//not avaliable
		document.getElementById("price_element").innerHTML = ":  (  )<link itemprop='availability' href='http://schema.org/OutOfStock' />";
		document.getElementById("content").remove();
	}
}

function categoryFill(category_raw) {
	// w-Wrist
	// p-Pocket
	// c-Complicated/rare
	// l-ladies
	// m-military
	// t-top
	var dict = {"w":", ",
				"p":",",
				"c":",,",
				"l":"",
				"m":",, , ",
				"t":",,"};
	categories = category_raw.split(" ");
	metaKeywords = []
	for (var i = categories.length - 1; i >= 0; i--) {
		try {
			metaKeywords.push(dict[categories[i]]);
		} catch(domException) {}
	}
	metaKeywords.push("");
	document.getElementById("meta_keywords").content = metaKeywords.join(",");
}

function mobileAdapt() {
	if ((typeof window.orientation !== "undefined") || (navigator.userAgent.indexOf('IEMobile') !== -1)) {
		if (document.readyState == 'interactive' || document.readyState == 'complete') {
			document.getElementsByClassName("item_pic")[0].style.width = "100%";
			document.getElementsByClassName("form-box")[0].style.width = "100%";
			document.getElementsByClassName("item_desc_1")[0].style.width = "100%";
		} else {
			window.onload = function() {
				document.getElementsByClassName("item_pic")[0].style.width = "100%";
				document.getElementsByClassName("form-box")[0].style.width = "100%";
				document.getElementsByClassName("item_desc_1")[0].style.width = "100%";
			}
		}
		
	}
}

function makeImages(id, num) {
	var carousel = document.getElementsByClassName("owl-carousel")[0];
	for (var i = 1; i <= num; i++) {
		var formattedNumber = ("0" + i).slice(-2); //attach a 0
		var imgLink = "/img/ref"+id+"-"+formattedNumber+".jpg";

		var box = document.createElement("div");
		var link = document.createElement("a");
		var image = document.createElement("img");
		image.src = imgLink;
		image.alt = "";
		image.setAttribute("itemprop","image"); //for schema.org
		link.href = imgLink;
		link.target = "_blank";
		
		link.appendChild(image);
		box.appendChild(link);
		carousel.appendChild(box);
	}
	$(".owl-carousel").owlCarousel({
		margin:10,
		autoWidth:false,
		items:1,
		loop:true,
		nav:true,
		dotsEach:true,
		navText : ['&#10096;','&#10097;']
	});
}

function makeStats(data) {
	var stats = data.querySelectorAll("stat");
	var statsBox = document.getElementById("stats");

	for (var i = 0; i < stats.length; i++) {
		var statContainer = document.createElement("li");
		var statTitle = document.createElement("span");
		statTitle.innerHTML = stats[i].attributes.title.nodeValue;
		statContainer.appendChild(statTitle);

		var numStars = stats[i].innerHTML;

		var yellowStars = 0;
		var greenStars = 0;
		var noStars = 0;

		if (numStars <= 8) {
			//8 or less
			yellowStars = numStars;
			noStars = 10-numStars;
		} else if (numStars > 8 && numStars <= 10) {
			//9 or 10
			yellowStars = 8;
			greenStars = numStars-8;
			noStars = 10-numStars;
		} else {
			//more than 10
			yellowStars = 8;
			greenStars = numStars-8;
		}
		for (var a = 0; a < yellowStars; a++) {
			var star = document.createElement("img");
			star.src = "p1.gif";
			statContainer.appendChild(star);
		}
		for (var b = 0; b < greenStars; b++) {
			var star = document.createElement("img");
			star.src = "p2.gif";
			statContainer.appendChild(star);
		}
		for (var c = 0; c < noStars; c++) {
			var star = document.createElement("img");
			star.src = "p0.gif";
			statContainer.appendChild(star);
		}
		statsBox.appendChild(statContainer);
	}
}

function finishedRendering() {
	//Yandex ads
	(function(w, d, n, s, t) {
		w[n] = w[n] || [];
		w[n].push(function() {
			Ya.Context.AdvManager.render({
				blockId: "R-A-196885-5",
				renderTo: "yandex_rtb_R-A-196885-5",
				async: true
			});
		});
		t = d.getElementsByTagName("script")[0];
		s = d.createElement("script");
		s.type = "text/javascript";
		s.src = "//an.yandex.ru/system/context.js";
		s.async = true;
		t.parentNode.insertBefore(s, t);
	})(this, this.document, "yandexContextAsyncCallbacks");
	
	//Google anal
	(function(i,s,o,g,r,a,m){i['GoogleAnalyticsObject']=r;i[r]=i[r]||function(){
	(i[r].q=i[r].q||[]).push(arguments)},i[r].l=1*new Date();a=s.createElement(o),
	m=s.getElementsByTagName(o)[0];a.async=1;a.src=g;m.parentNode.insertBefore(a,m)
	})(window,document,'script','//www.google-analytics.com/analytics.js','ga');
	ga('create', 'UA-46303716-1', 'german242.com');
	ga('send', 'pageview');

	//Yandex anal
	(function(m,e,t,r,i,k,a){m[i]=m[i]||function(){(m[i].a=m[i].a||[]).push(arguments)};
	m[i].l=1*new Date();k=e.createElement(t),a=e.getElementsByTagName(t)[0],k.async=1,k.src=r,a.parentNode.insertBefore(k,a)})
	(window, document, "script", "https://mc.yandex.ru/metrika/tag.js", "ym");

	ym(56078464, "init", {
		clickmap:true,
		trackLinks:true,
		accurateTrackBounce:true
	});

	//Hotlog
	var hot_s = document.createElement('script');
	hot_s.type = 'text/javascript'; hot_s.async = true;
	hot_s.src = 'https://js.hotlog.ru/dcounter/350748.js';
	hot_d = document.getElementById('hotlog_dyn');
	hot_d.appendChild(hot_s);
}